
import {  getInfo } from '@/api/login'
import { getToken } from '@/utils/auth'
import { isHttp, isEmpty } from "@/utils/validate"
import defAva from '@/assets/images/profile.jpg'
import unifiedLoginSDK from "oauth2-login-sdk";

interface UserState {
  token: string | undefined
  id: string | number
  name: string
  nickName: string
  avatar: string
  roles: string[]
  permissions: string[]
}

const useUserStore = defineStore(
  'user',
  {
    state: (): UserState => ({
      token: getToken(),
      id: '',
      name: '',
      nickName: '',
      avatar: '',
      roles: [],
      permissions: []
    }),
    actions: {
      // 获取用户信息
      getInfo() {
        return new Promise((resolve, reject) => {
          getInfo().then(res => {
            // const user = res.user
            const user = res
            // let avatar = user.avatar || ''
            let avatar = ''
            if (!isHttp(avatar)) {
              avatar = (isEmpty(avatar)) ? defAva : import.meta.env.VITE_APP_BASE_API + avatar
            }
            if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
              this.roles = res.roles
              this.permissions = res.permissions
            } else {
              this.roles = ['ROLE_DEFAULT']
            }
            this.id = user.userId || ''
            this.name = user.username || ''
            this.nickName = user.nickName || ''
            this.avatar = avatar
            /* 初始密码提示 */
            // if(res.isDefaultModifyPwd) {
            //   ElMessageBox.confirm('您的密码还是初始密码，请修改密码！',  '安全提示', {  confirmButtonText: '确定',  cancelButtonText: '取消',  type: 'warning' }).then(() => {
            //     router.push({ name: 'Profile', params: { activeTab: 'resetPwd' } })
            //   }).catch(() => {})
            // }
            // /* 过期密码提示 */
            // if(!res.isDefaultModifyPwd && res.isPasswordExpired) {
            //   ElMessageBox.confirm('您的密码已过期，请尽快修改密码！',  '安全提示', {  confirmButtonText: '确定',  cancelButtonText: '取消',  type: 'warning' }).then(() => {
            //     router.push({ name: 'Profile', params: { activeTab: 'resetPwd' } })
            //   }).catch(() => {})
            // }
            resolve(res)
          }).catch(error => {
            reject(error)
          })
        })
      },
      // 退出系统
      logOut() {
        return new Promise<void>((resolve, reject) => {
          unifiedLoginSDK.logout()
        })
      }
    }
  })

export default useUserStore
